MaxNumberOfTyresOut = 1

'''
InvalidateLap App 0.1 for Assetto Corsa
for CSP v0.1.37 and later
'''
import ac, acsys
import sys, time
from sim_info import info

appWindow = 0
timer = 0
bInvalidated = False
sAppError=""
lastLap = -2

def CheckOffTrack():
    global MaxNumberOfTyresOut, lastLap, bInvalidated, appWindow
    global sAppError
    if sAppError!="":
        ac.setTitle(appWindow, sAppError)
    else:
        currentLap = ac.getCarState(0, acsys.CS.LapCount)
        if lastLap != currentLap:
            bInvalidated = False
            lastLap = currentLap
        CurrNumberOfTyresOut = info.physics.numberOfTyresOut
        if CurrNumberOfTyresOut >= MaxNumberOfTyresOut:
            if CurrNumberOfTyresOut>1:
                ac.setTitle(appWindow," OFF track: " + str(CurrNumberOfTyresOut) + " wheels" )
            else:
                ac.setTitle(appWindow," OFF track: " + str(CurrNumberOfTyresOut) + " wheel" )
            if not bInvalidated:
                bInvalidated = True
                ac.ext_markLapAsSpoiled() # CSP function
        else:
            ac.setTitle(appWindow," ON track")

def acUpdate(deltaT):
    global timer
    timer += deltaT
    if timer > 0.05:
        timer = 0.0
        CheckOffTrack()

def acMain(ac_version):
    global appWindow, sAppError
    appWindow = ac.newApp("InvalidateLap")
    ac.setTitle(appWindow,"InvalidateLap")
    ac.setSize(appWindow, 200, 25)
    ac.setIconPosition(appWindow, 0, -10)
    ac.setBackgroundOpacity(appWindow, 0)
    ac.setBackgroundOpacity(appWindow, 0)
    sAppError = ''
    try:
        sVerCode = ac.ext_patchVersionCode()
        if int(sVerCode)<=893: # version code for v0.1.36
            sAppError = str(ac.ext_patchVersion()) + ' CustomShaderPatch too old '
    except:
        sAppError = 'Shaders Patch not enabled or installed.'
    return "InvalidateLap"

def acShutdown(*args):
    pass
